<?php

$common_entity_attrs = array (

    /* ----------- start -----------*/
    'supannCodeEntite' => array (
      'label' => 'Identifier',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'required' => 1,
      'multiple' => 0,
      'check_data' => array (
        'regex' => array(
          'params' => array(
            'regex' => '/^[a-zA-Z0-9_-]+$/',
          ),
          'msg' => "Identifier could only contain letter, number, dashes (-) or underscores (_).",
        ),
      ),
      'validation' => array (
        array (
          'msg' => "This identifier is already assigned to an entity.",
          'object_type' => 'supannEntite',
          'filter' => '(supannCodeEntite=%{val})',
          'except_current_object' => 1,
          'result' => 0,
        ),
        array (
          'msg' => "This identifier is already assigned to an establishment.",
          'object_type' => 'supannOrg',
          'filter' => '(supannCodeEntite=%{val})',
          'result' => 0
        ),
      ),
      'view' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'description' => array (
      'label' => 'Description',
      'ldap_type' => 'ascii',
      'html_type' => 'textarea',
      'required' => 1,
      'multiple' => 0,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'facsimileTelephoneNumber' => array (
      'label' => 'Fax',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'required' => 0,
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'postalAddress' => array (
      'label' => 'Postal address',
      'ldap_type' => 'postaladdress',
      'html_type' => 'textarea',
      'required' => 0,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'telephoneNumber' => array (
      'label' => 'Landline number',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'required' => 0,
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannRefId' => array (
      'label' => 'Other identifiers',
      'help_info' => 'Identifiers of this LDAP object in other applications. These identifiers must be prefix with application name in uppercase and in brackets.',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'required' => 0,
      'multiple' => 1,
      'check_data' => array (
        'regex' => array(
          'msg' => "Identifiers must only contain alphanumeric values, dots (.) and dashes (-) and be prefixed with application name in uppercase and in brackets.",
          'params' => array('regex' => '/^\{[A-Z0-9-_\.]+}[a-zA-Z0-9-_\.]*$/'),
        ),
      ),
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannTypeEntite' => array (
      'label' => 'Entity types',
      'ldap_type' => 'ascii',
      'html_type' => 'supannTypeEntite',
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1
      ),
    ),
    /* ----------- end -----------*/

);

