<?php
/*******************************************************************************
 * Copyright (C) 2007 Easter-eggs
 * http://ldapsaisie.labs.libre-entreprise.org
 *
 * Author: See AUTHORS file in top-level directory.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

******************************************************************************/

require('config.LSobjects.common.php');

$GLOBALS['LSobjects']['supannEntite'] = array (
  'objectclass' => array(
    'supannEntite',
    'organizationalUnit',
  ),
  'rdn' => 'supannCodeEntite',
  'container_dn' => 'ou=structures',
  'display_name_format' => '%{ou}',
  'label' => 'Entities',
  'displayAttrName' => true,

  // triggers
  'before_delete' => 'supannCheckEntityCouldBeDeleted',

  'customActions' => array (
    'showTechInfo' => array (
      'function' => 'showTechInfo',
      'label' => 'Show technical information',
      'hideLabel' => True,
      'noConfirmation' => true,
      'disableOnSuccessMsg' => true,
      'icon' => 'tech_info',
      'rights' => array (
        'admin',
      ),
    ),
  ),

  // LSform
  'LSform' => array (
    'ajaxSubmit' => 1,
    // Layout
    'layout' => array (
      'infos' => array(
        'label' => 'Information',
        'args' => array (
          'supannCodeEntite',
          'supannCodeEntiteParent',
          'supannTypeEntite',
          'ou',
          'description',
          'supannRefId',
        ),
      ),
      'com' => array (
        'label' => 'Communication',
        'args' => array (
          'postalAddress',
          'telephoneNumber',
          'facsimileTelephoneNumber',
        ),
      ),
    ),
  ),

  // LSrelation
  'LSrelation' => array(
    'children' => array(
      'label' => 'Children entities',
      'emptyText' => "Have any child entity.",
      'LSobject' => 'supannEntite',
      'linkAttribute' => 'supannCodeEntiteParent',
      'linkAttributeValue' => 'supannCodeEntite',
      'canEdit_attribute' => 'supannCodeEntiteParent',
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
    ),
    'godfather' => array(
      'label' => 'Godfather of ...',
      'emptyText' => "Doesn't sponsor anybody.",
      'LSobject' => "supannPerson",
      'linkAttribute' => "supannParrainDN",
      'linkAttributeValue' => "dn",
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
    ),
  ),

  'LSsearch' => array (
    'attrs' => array (
      'ou',
      'description',
      'supannCodeEntite',
      'supannRefId',
      'telephoneNumber',
      'facsimileTelephoneNumber',
      'postalAddress',
    ),
  ),

  'attrs' => array_merge($common_entity_attrs, array (
  
    /* ----------- start -----------*/
    'ou' => array (
      'label' => "Name",
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'required' => 1,
      'validation' => array (
        array (
          'object_type' => 'supannEntite',
          'filter' => 'ou=%{val}',
          'result' => 0
        ),
      ),
      'view' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannCodeEntiteParent' => array (
      'label' => 'Parent entity',
      'ldap_type' => 'ascii',
      'html_type' => 'select_object',
      'html_options' => array(
        'selectable_object' => array(
          array (
            'object_type' => 'supannEntite',
            'value_attribute' => 'supannCodeEntite',
          ),
          array (
            'object_type' => 'supannOrg',
            'value_attribute' => 'supannCodeEntite',
          ),
        ),
      ),
      'validation' => array (
        array (
          'msg' => 'This entity does not exists.',
          'filter' => '(&(objectClass=supannEntite)(supannCodeEntite=%{val}))',
          'result' => 1
        ),
      ),
      'required' => 1,
      'multiple' => 0,
      'view' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

  )), // End of attrs & array_merge
);

@include('config.LSobjects.phpLdapAdmin.php');
