<?php
/*******************************************************************************
 * Copyright (C) 2007 Easter-eggs
 * http://ldapsaisie.labs.libre-entreprise.org
 *
 * Author: See AUTHORS file in top-level directory.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

******************************************************************************/

$GLOBALS['LSobjects']['supannGroup'] = array (
  'objectclass' => array(
    'groupOfNames',
    'supannGroupe',
  ),
  'rdn' => 'cn',
  'container_dn' => 'ou=Groups',
  'display_name_format' => '%{cn}',
  'label' => 'Groups',
  'displayAttrName' => true,

  'customActions' => array (
    'showTechInfo' => array (
      'function' => 'showTechInfo',
      'label' => 'Show technical information',
      'hideLabel' => True,
      'noConfirmation' => true,
      'disableOnSuccessMsg' => true,
      'icon' => 'tech_info',
      'rights' => array (
        'admin',
      ),
    ),
  ),

  'LSrelation' => array(
    'godfather' => array(
      'label' => 'Godfather of ...',
      'emptyText' => "Doesn't sponsor any user.",
      'LSobject' => "supannPerson",
      'linkAttribute' => "supannParrainDN",
      'linkAttributeValue' => "dn",
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
    ),
  ),

  'attrs' => array (

    /* ----------- start -----------*/
    'cn' => array (
      'label' => 'Name',
      'help_info' => "Group name must only contain alphanumeric values and dashes (-).",
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'required' => 1,
      'check_data' => array (
        'regex' => array(
          'msg' => "Group name must only contain alphanumeric values and dashes (-).",
          'params' => array('regex' => '/^[a-zA-Z0-9\-]*$/'),
        ),
      ),
      'validation' => array (
        array (
          'filter' => 'cn=%{val}',
          'object_type' => 'supannGroup',
          'result' => 0,
          'msg' => 'This group name is already affected.',
        ),
      ),
      'view' => 1,
      'rights' => array(
        'admin' => 'w',
        'owner' => 'w',
        'reader' => 'r',
        'sysaccount' => 'r',
      ),
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'owner' => array (
      'label' => 'Owners',
      'ldap_type' => 'ascii',
      'html_type' => 'select_object',
      'html_options' => array(
        'selectable_object' => array(
          'object_type' => 'supannPerson',
          'value_attribute' => 'dn',
        ),
      ),
      'validation' => array (
        array (
          'basedn' => '%{val}',
          'object_type' => 'supannPerson',
          'result' => 1,
        ),
      ),
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'owner' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1,
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannGroupeAdminDN' => array (
      'label' => 'Administrators of members',
      'ldap_type' => 'ascii',
      'html_type' => 'select_object',
      'html_options' => array(
        'selectable_object' => array (
          array (
            'object_type' => 'supannPerson',
            'value_attribute' => 'dn',
          ),
          array (
            'object_type' => 'supannGroup',
            'value_attribute' => 'dn',
          ),
        ),
      ),
      'validation' => array (
        array (
          'basedn' => '%{val}',
          'filter' => '(|(objectClass=supannPerson)(objectClass=supannGroupe))',
          'result' => 1,
        ),
      ),
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'owner' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1,
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannGroupeLecteurDN' => array (
      'label' => 'Readers of members',
      'ldap_type' => 'ascii',
      'html_type' => 'select_object',
      'html_options' => array(
        'selectable_object' => array (
          array (
            'object_type' => 'supannPerson',
            'value_attribute' => 'dn',
          ),
          array (
            'object_type' => 'supannGroup',
            'value_attribute' => 'dn',
          ),
        ),
      ),
      'validation' => array (
        array (
          'basedn' => '%{val}',
          'filter' => '(|(objectClass=supannPerson)(objectClass=supannGroupe))',
          'result' => 1,
        ),
      ),
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'owner' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1,
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannGroupeDateFin' => array (
      'label' => 'Validity end date',
      'ldap_type' => 'naiveDate',
      'html_type' => 'date',
      'html_options' => array(
        'date' => array(
          'time' => 1,
          'manual' => 1,
        ),
      ),
      'multiple' => 0,
      'rights' => array(
        'admin' => 'w',
        'owner' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1,
      )
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'member' => array (
      'label' => 'Members',
      'ldap_type' => 'ascii',
      'html_type' => 'select_object',
      'html_options' => array(
        'selectable_object' => array(
          'object_type' => 'supannPerson',
          'value_attribute' => 'dn',
        )
      ),
      'validation' => array (
        array (
          'basedn' => '%{val}',
          'object_type' => 'supannPerson',
          'result' => 1
        ),
      ),
      'required' => 1,
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'owner' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      )
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'description' => array (
      'label' => 'Description',
      'ldap_type' => 'ascii',
      'html_type' => 'textarea',
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'owner' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannRefId' => array (
      'label' => 'Other identifiers',
      'help_info' => 'Identifiers of this LDAP object in other applications. These identifiers must be prefix with application name in uppercase and in brackets.',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'multiple' => 1,
      'check_data' => array (
        'regex' => array(
          'msg' => "Identifiers must only contain alphanumeric values, dots (.) and dashes (-) and be prefixed with application name in uppercase and in brackets.",
          'params' => array('regex' => '/^\{[A-Z0-9-_\.]+}[a-zA-Z0-9-_\.]*$/'),
        ),
      ),
      'rights' => array(
        'admin' => 'w',
        'owner' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'create' => 1,
        'modify' => 1
      ),
    ),
    /* ----------- end -----------*/

  ),
);

@include('config.LSobjects.phpLdapAdmin.php');
