<?php
/*******************************************************************************
 * Copyright (C) 2007 Easter-eggs
 * http://ldapsaisie.labs.libre-entreprise.org
 *
 * Author: See AUTHORS file in top-level directory.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

******************************************************************************/

$GLOBALS['LSobjects']['supannPerson'] = array (
  'objectclass' => array(
    'top',
    'inetOrgPerson',
    'eduPerson',
    'supannPerson',
  ),
  'rdn' => 'uid',
  'container_dn' => 'ou=people',

  'LSaddons' => array (
    'exportSearchResultAsCSV',
  ),

  'customActions' => array (
    'showTechInfo' => array (
      'function' => 'showTechInfo',
      'label' => 'Show technical information',
      'hideLabel' => True,
      'noConfirmation' => true,
      'disableOnSuccessMsg' => true,
      'icon' => 'tech_info',
      'rights' => array (
        'admin',
      ),
    ),
  ),

  'display_name_format' => '%{displayName}',
  'label' => 'People',
  'displayAttrName' => true,

  // LSrelation
  'LSrelation' => array(
    'groups' => array(
      'label' => 'Belongs to groups ...',
      'emptyText' => "Doesn't belong to any group.",
      'LSobject' => 'supannGroup',
      'linkAttribute' => "member",
      'linkAttributeValue' => "dn",
      'canEdit_attribute' => 'member',
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
        'self' => 'r',
      ),
    ),
    'godfather' => array(
      'label' => 'Godfather of ...',
      'emptyText' => "Doesn't sponsor any user.",
      'LSobject' => "supannPerson",
      'linkAttribute' => "supannParrainDN",
      'linkAttributeValue' => "dn",
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
        'self' => 'r',
      ),
    ),
  ),

  // LSform
  'LSform' => array (
    'ajaxSubmit' => 1,
    // Layout
    'layout' => array (
      'general' => array(
        'label' => 'General',
        'img' => 1,
        'args' => array (
          'uid',
          'supannCivilite',
          'title',
          'givenName',
          'sn',
          'displayName',
          'cn',
          'eduPersonNickname',
          'supannRessourceEtat',
          'supannRessourceEtatDate',
          'userPassword',
          'description',
          'jpegPhoto',
        ),
      ),
      'perso' => array (
        'label' => 'Personal information',
        'args' => array (
          'eduPersonAffiliation',
          'eduPersonPrimaryAffiliation',
          'supannNomDeNaissance',
          'supannPrenomsEtatCivil',
          'supannOIDCDateDeNaissance',
          'supannOIDCGenre',
        ),
      ),
      'org' => array (
        'label' => 'Organization',
        'args' => array (
          'supannEtablissement',
          'eduPersonOrgDN',
          'supannEntiteAffectation',
          'eduPersonOrgUnitDN',
          'supannEntiteAffectationPrincipale',
          'eduPersonPrimaryOrgUnitDN',
          'supannRoleEntite',
          'supannRoleGenerique',
          'supannTypeEntiteAffectation',
          'supannCodePopulation',
          'supannParrainDN',
        ),
      ),
      'procontact' => array (
        'label' => 'Professional contact information',
        'args' => array (
          'mail',
          'supannAutreMail',
          'mailForwardingAddress',
          'telephoneNumber',
          'supannAutreTelephone',
          'mobile',
          'facsimileTelephoneNumber',
          'postalAddress',
          'preferredLanguage',
          'supannListeRouge',
        ),
      ),
      'persocontact' => array (
        'label' => 'Personal contact information',
        'args' => array (
          'supannMailPerso',
          'homePhone',
          'homePostalAddress',
          'labeledURI',
        ),
      ),
      'privatecontact' => array (
        'label' => 'Private contact information',
        'args' => array (
          'supannMailPrive',
          'supannTelephonePrive',
          'supannAdressePostalePrivee',
        ),
      ),
      'student' => array (
        'label' => 'Student',
        'args' => array (
          'supannCodeINE',
          'supannEtuId',
          'supannEtuInscription',
          'supannEtuDiplome',
          'supannEtuTypeDiplome',
          'supannEtuRegimeInscription',
          'supannEtuSecteurDisciplinaire',
          'supannEtuAnneeInscription',
          'supannEtuCursusAnnee',
          'supannEtuElementPedagogique',
          'supannEtuEtape',
          'supannEtuDateFin',
        ),
      ),
      'agent' => array (
        'label' => 'Agent',
        'args' => array (
          'supannEmpId',
          'supannEmpCorps',
          'supannEmpDateFin',
          'supannEmpProfil',
          'supannActivite',
        ),
      ),
      'external' => array (
        'label' => 'External person',
        'args' => array (
          'supannExtDateFin',
          'supannExtProfil',
        ),
      ),
      'tech' => array (
        'label' => 'Technical information',
        'args' => array (
          'supannRefId',
          'userCertificate',
          'supannAliasLogin',
          'eduPersonUniqueId',
          'eduPersonPrincipalName',
          'eduPersonPrincipalNamePrior',
          'supannConsentement',
        ),
      ),
    ), // fin Layout
  ), // fin LSform

  'LSsearch' => array (
    'attrs' => array (
      'givenName',
      'sn',
      'displayName',
      'cn' => array(
         'searchLSformat' => '(%{name}=%{pattern~})',
         'approxLSformat' => '(%{name}=~%{pattern~})',
       ),
      'uid',
      'mail',
      'supannMailPerso',
    ),
    'params' => array (
      'sortBy' => 'displayName',
      'sizelimit' => 300
    ),
    'extraDisplayedColumns' => array (
      'mail' => array (
        'label' => 'Mail',
        'LSformat' => '%{mail}',
      ),
    ),
    'customActions' => array (
      'exportSearchResultAsCSV' => array (
        'label' => 'Export result as CSV',
        'icon' => 'export_csv',
        'function' => 'exportSearchResultAsCSV',
        'noConfirmation' => true,
        'disableOnSuccessMsg' => true,
        'rights' => array (
          'admin',
        ),
      ),
    ),
  ),

  // Attributes
  'attrs' => array (

    /***************************************************************************************************
     *                                   General info attributes
     **************************************************************************************************/

    /* ----------- start -----------*/
    'uid' => array (
      'label' => 'Identifier',
      'help_info' => "Identifier could only contain letters, digits, dots (.), dashes (-) and underscores (_).",
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'html_options' => array(
        'generate_value_format' => '%{givenName}.%{sn}',
        'autoGenerateOnModify' => true,   // default : false
        'withoutAccent' => 1,
        'replaceSpaces' => '.',
        'lowerCase' => 1
      ),
      'required' => 1,
      'check_data' => array (
        'regex' => array(
          'msg' => "Identifier could only contain letters, digits, dots (.), dashes (-) and underscores (_).",
          'params' => array('regex' => '/^[a-zA-Z0-9-_\.]*$/'),
        ),
      ),
      'validation' => array (
        array (
          'filter' => '(|(uid=%{val})(supannAliasLogin=%{val}))',
          'result' => 0,
          'msg' => 'This identifier is already used.',
          'except_current_object' => true,
        ),
      ),
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
      'dependAttrs' => array(
        'eduPersonPrincipalName',
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannCivilite' => array (
      'label' => 'Civility',
      'ldap_type' => 'ascii',
      'html_type' => 'select_box',
      'html_options' => array (
        'get_possible_values' => 'supannGetCivilitePossibleValues',
        'inline' => true,
        'sort' => false,
      ),
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'title' => array (
      'label' => 'Title',
      'help_info' => "Title of civility, quality or predicate that must precede the display of the name of the person: Doctor, Professor, Master, Father, etc.",
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'givenName' => array (
      'label' => 'First Name',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'required' => 1,
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
      'dependAttrs' => array (
        'cn',
        'displayName',
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'sn' => array (
      'label' => 'Last Name',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'required' => 1,
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
      'dependAttrs' => array (
        'cn',
        'displayName',
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'displayName' => array (
      'label' => 'Full Name',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'html_options' => array(
        'generate_value_format' => '%{givenName} %{sn}',
        'autoGenerateOnModify' => true,   // default : false
        'autoGenerateOnCreate' => true    // default : false
      ),
      'generate_function' => 'generate_displayName',
      'required' => 1,
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
      'dependAttrs' => array('cn'),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'cn' => array (
      'label' => 'Full Name (without accents)',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'generate_function' => 'generate_cn',
      'required' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'eduPersonNickname' => array (
      'label' => 'Nickname',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannRessourceEtat' => array (
      'label' => 'Resources status',
      'ldap_type' => 'ascii',
      'html_type' => 'supannRessourceEtat',
      'multiple' => true,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannRessourceEtatDate' => array (
      'label' => 'Resources status (with dates)',
      'ldap_type' => 'ascii',
      'html_type' => 'supannRessourceEtatDate',
      'multiple' => true,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'userPassword' => array (
      'label' => 'Password',
      'help_info' => 'A password must contain at least 8 characters and contains at least one character that match with 3 of this types :<ul><li>Uppercase unaccent character</li><li>Lowercase unaccent character</li><li>Digit</li><li>Anything that is not a letter or a digit</li></ul>',
      'ldap_type' => 'password',
      'ldap_options' => array (
        'encode' => 'ssha',
      ),
      'html_type' => 'password',
      'html_options' => array(
        'generationTool' => true,
        'viewHash' => true,
        'autoGenerate' => false,
        'confirmInput' => true,
        'lenght' => 8,
        'chars' => array (
          array(
            'nb' => 3,
            'chars' => 'abcdefijklmnopqrstuvwxyz',
          ),
          '0123456789',
          '*$.:/_-[]{}=~',
        ),
        'mail' => array(
          'send' => 1,
          'ask' => 1,
          'subject' => "Your new credentials.",
          'msg' => "Your password has been changed.\nLogin : %{uid}\nNew password : %{password}",
          'mail_attr' => 'mail',
        ),
        'confirmChange' => True,
        'confirmChangeQuestion' => "Do you confirm change of this user's password?",
      ),
      'check_data' => array(
        'password' => array(
          'msg' => 'A password must contain at least 8 characters and contains at least one character that match with 3 of this types :<ul><li>Uppercase unaccent character</li><li>Lowercase unaccent character</li><li>Digit</li><li>Anything that is not a letter or a digit</li></ul>',
          'params' => array(
            'minLength' => 8,
            'regex' => array (
              '/[A-Z]/',
              '/[a-z]/',
              '/[0-9]/',
              '/[^A-Za-z0-9]/',
            ),
            'minValidRegex' => 3
          ),
        ),
      ),
      'rights' => array(
        'self' => 'w',
        'admin' => 'w',
      ),
      'form' => array (
        'modify' => 1,
        'create' => 1,
        'lostPassword' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'description' => array (
      'label' => 'Description/comment',
      'ldap_type' => 'ascii',
      'html_type' => 'textarea',
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'jpegPhoto' => array (
      'label' => 'Picture',
      'ldap_type' => 'image',
      'html_type' => 'image',
      'required' => 0,
      'view' => 1,
      'check_data' => array (
        'filesize' => array(
          'msg' => "File size is not valid.",
          'params' => array(
            'maxSize' => 3000000   // taille du fichier en octets
          ),
        ),
        'imagefile' => array(
          'msg' => "File type is not valid.",
        ),
      ),
      'form' => array (
        'modify' => 1
      ),
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
    ),
    /* ----------- end -----------*/

    /***************************************************************************************************
     *                                   Personal info attributes
     **************************************************************************************************/

     /* ----------- start -----------*/
     'eduPersonAffiliation' => array (
       'label' => 'eduPerson profils',
       'ldap_type' => 'ascii',
       'html_type' => 'select_box',
       'html_options' => array (
         'get_possible_values' => 'supannGetAffiliationPossibleValues',
       ),
       'validation' => array(
         array(
           'msg' => 'Affiliate and member are incompatible.',
           'function' => 'supannCheckEduPersonAffiliation',
         ),
       ),
       'multiple' => 1,
       'rights' => array(
         'self' => 'r',
         'admin' => 'w',
         'sysaccount' => 'r',
       ),
       'view' => 1,
       'form' => array (
         'modify' => 1,
         'create' => 1
       ),
     ),
     /* ----------- end -----------*/

     /* ----------- start -----------*/
     'eduPersonPrimaryAffiliation' => array (
       'label' => 'Principal eduPerson profils',
       'ldap_type' => 'ascii',
       'html_type' => 'select_list',
       'html_options' => array (
         'possible_values' => array('' => '-'),
         'get_possible_values' => 'supannGetAffiliationPossibleValues',
       ),
       'validation' => array(
         array(
           'msg' => "Principal affiliation must be one of the user's affiliations.",
           'function' => 'supannCheckEduPersonPrimaryAffiliation',
         ),
       ),
       'multiple' => 0,
       'rights' => array(
         'self' => 'r',
         'admin' => 'w',
         'sysaccount' => 'r',
       ),
       'view' => 1,
       'form' => array (
         'modify' => 1,
         'create' => 1
       ),
     ),
     /* ----------- end -----------*/

     /* ----------- start -----------*/
     'supannNomDeNaissance' => array (
       'label' => 'Birth name',
       'ldap_type' => 'ascii',
       'html_type' => 'text',
       'multiple' => 0,
       'rights' => array(
         'self' => 'r',
         'admin' => 'w',
         'sysaccount' => 'r',
       ),
       'view' => 1,
       'form' => array (
         'modify' => 1,
         'create' => 1
       ),
     ),
     /* ----------- end -----------*/

     /* ----------- start -----------*/
     'supannPrenomsEtatCivil' => array (
       'label' => 'Civil status firthnames',
       'ldap_type' => 'ascii',
       'html_type' => 'text',
       'multiple' => 0,
       'rights' => array(
         'self' => 'r',
         'admin' => 'w',
         'sysaccount' => 'r',
       ),
       'view' => 1,
       'form' => array (
         'modify' => 1,
         'create' => 1
       ),
     ),
     /* ----------- end -----------*/

     /* ----------- start -----------*/
     'supannOIDCDateDeNaissance' => array (
       'label' => 'Birthdate',
       'ldap_type' => 'naiveDate',
       'ldap_options' => array(
         'format' => '%Y-%m-%d',
       ),
       'html_type' => 'date',
       'html_options' => array(
         'time' => false,
         'showNowButton' => false,
         'showTodayButton' => false,
       ),
       'multiple' => 0,
       'rights' => array(
         'self' => 'r',
         'admin' => 'w',
         'sysaccount' => 'r',
       ),
       'view' => 1,
       'form' => array (
         'modify' => 1,
         'create' => 1
       ),
     ),
     /* ----------- end -----------*/

     /* ----------- start -----------*/
     'supannOIDCGenre' => array (
       'label' => 'Gender',
       'ldap_type' => 'ascii',
       'html_type' => 'select_box',
       'html_options' => array (
         'get_possible_values' => 'supannGetOIDCGenrePossibleValues',
         'sort' => false,
       ),
       'rights' => array(
         'self' => 'r',
         'admin' => 'w',
         'sysaccount' => 'r',
       ),
       'view' => 1,
       'form' => array (
         'modify' => 1,
         'create' => 1
       ),
     ),
     /* ----------- end -----------*/

    /***************************************************************************************************
     *                                   Organizational info attributes
     **************************************************************************************************/

    /* ----------- start -----------*/
    'supannEtablissement' => array (
      'label' => 'Establishment',
      'ldap_type' => 'ascii',
      'html_type' => 'supannEtablissement',
      'required' => 1,
      'default_value' => $GLOBALS['LS_SUPANN_ETABLISSEMENT_UAI'],
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
      ),
      'dependAttrs' => array(
        'eduPersonOrgDN',
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'eduPersonOrgDN' => array (
      'label' => 'Establishment (DN)',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'generate_function' => 'generate_eduPersonOrgDN',
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannEntiteAffectation' => array (
      'label' => 'Assignment entity',
      'ldap_type' => 'ascii',
      'html_type' => 'select_object',
      'html_options' => array(
        'selectable_object' => array(
          'object_type' => 'supannEntite',
          'value_attribute' => 'supannCodeEntite',
        ),
      ),
      'multiple' => 1,
      'validation' => array (
        array (
          'msg' => "This entity doesn't exists.",
          'object_type' => 'supannEntite',
          'filter' => 'supannCodeEntite=%{val}',
          'result' => 1
        ),
      ),
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
      'dependAttrs' => array(
        'eduPersonOrgUnitDN',
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'eduPersonOrgUnitDN' => array (
      'label' => 'Assignment entity (DN)',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'multiple' => 1,
      'generate_function' => 'generate_eduPersonOrgUnitDN',
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannEntiteAffectationPrincipale' => array (
      'label' => 'Principal assignment entity',
      'ldap_type' => 'ascii',
      'html_type' => 'select_object',
      'html_options' => array(
        'selectable_object' => array(
          'object_type' => 'supannEntite',
          'value_attribute' => 'supannCodeEntite',
        ),
      ),
      'multiple' => 0,
      'validation' => array (
        array (
          'msg' => "This entity doesn't exists.",
          'object_type' => 'supannEntite',
          'filter' => 'supannCodeEntite=%{val}',
          'result' => 1
        ),
      ),
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
      'dependAttrs' => array(
        'eduPersonPrimaryOrgUnitDN',
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'eduPersonPrimaryOrgUnitDN' => array (
      'label' => 'Principal assignment entity (DN)',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'multiple' => 0,
      'generate_function' => 'generate_eduPersonPrimaryOrgUnitDN',
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannRoleEntite' => array (
      'label' => 'Role in entities',
      'ldap_type' => 'ascii',
      'html_type' => 'supannRoleEntite',
      'multiple' => 1,
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannRoleGenerique' => array (
      'label' => 'Role in entities: list of roles',
      'ldap_type' => 'ascii',
      'html_type' => 'supannRoleGenerique',
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannTypeEntiteAffectation' => array (
      'label' => 'Role in entities: list of entity types',
      'ldap_type' => 'ascii',
      'html_type' => 'supannTypeEntite',
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannCodePopulation' => array (
      'label' => 'Population',
      'ldap_type' => 'ascii',
      'html_type' => 'supannCodePopulation',
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannParrainDN' => array (
      'label' => 'Godfather',
      'help_info' => 'People who requested registration in the directory.',
      'ldap_type' => 'ascii',
      'html_type' => 'select_object',
      'html_options' => array(
        'selectable_object' => array(
          array (
            'object_type' => 'supannPerson',
            'value_attribute' => 'dn',
          ),
          array (
            'object_type' => 'supannGroup',
            'value_attribute' => 'dn',
          ),
          array (
            'object_type' => 'supannOrg',
            'value_attribute' => 'dn',
          ),
          array (
            'object_type' => 'supannEntite',
            'value_attribute' => 'dn',
          ),
        ),
      ),
      'multiple' => 1,
      'validation' => array (
        array (
          'msg' => "This object doesn't exists.",
          'basedn' => '%{val}',
          'result' => 1
        ),
      ),
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /***************************************************************************************************
     *                                   Professional contact info attributes
     **************************************************************************************************/

    /* ----------- start -----------*/
    'mail' => array (
      'label' => 'Professional e-mail address',
      'ldap_type' => 'ascii',
      'html_type' => 'mail',
      'multiple' => 1,
      'check_data' => array (
        'email' => array(
          'msg' => "Given email address is invalid.",
          'params' => array(
            'domain' => $GLOBALS['LS_SUPANN_MAIL_DOMAINS'],
          ),
        ),
      ),
      'validation' => array (
        array (
          'filter' => '(|(mail=%{val})(supannAutreMail=%{val}))',
          'result' => 0,
          'except_current_object' => true,
          'msg' => 'This e-mail address is already assigned.',
        ),
      ),
      'rights' => array(
        'self' => 'w',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannAutreMail' => array (
      'label' => 'Other professional e-mail address',
      'ldap_type' => 'ascii',
      'html_type' => 'mail',
      'multiple' => 1,
      'check_data' => array (
        'email' => array(
          'msg' => "Given email address is invalid.",
          'params' => array(
            'domain' => $GLOBALS['LS_SUPANN_MAIL_DOMAINS'],
          ),
        ),
      ),
      'validation' => array (
        array (
          'filter' => '(|(mail=%{val})(supannAutreMail=%{val})(supannMailPerso=%{val}))',
          'result' => 0,
          'except_current_object' => true,
          'msg' => 'This e-mail address is already assigned.',
        ),
      ),
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'mailForwardingAddress' => array (
      'label' => 'Forwarding e-mail address',
      'ldap_type' => 'ascii',
      'html_type' => 'mail',
      'check_data' => array (
        'email' => array(
          'msg' => "Given email address is invalid.",
        ),
      ),
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'telephoneNumber' => array (
      'label' => 'Landline number',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'multiple' => 1,
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannAutreTelephone' => array (
      'label' => 'Other phone numbers',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'multiple' => 1,
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'mobile' => array (
      'label' => 'Mobile phone number',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'multiple' => 1,
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'facsimileTelephoneNumber' => array (
      'label' => 'Fax',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'multiple' => 1,
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'postalAddress' => array (
      'label' => 'Postal address',
      'ldap_type' => 'postaladdress',
      'html_type' => 'textarea',
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'preferredLanguage' => array (
      'label' => 'Preferred language',
      'ldap_type' => 'ascii',
      'html_type' => 'select_list',
      'html_options' => array (
        'possible_values' => array(
          'fr' => 'French',
          'en' => 'English',
          'de' => 'German',
          'it' => 'Italian',
          'es' => 'Spanish',
        ),
        'sort' => false,
      ),
      'default_value' => 'fr',
      'rights' => array(
        'self' => 'w',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannListeRouge' => array (
      'label' => 'Red list',
      'ldap_type' => 'boolean',
      'ldap_options' => array(
        'true_value' => 'TRUE',
        'false_value' => 'FALSE',
      ),
      'html_type' => 'boolean',
      'no_value_label' => 'No (default)',
      'default_value' => 'yes',
      'required' => true,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /***************************************************************************************************
     *                                   Personal contact info attributes
     **************************************************************************************************/

    /* ----------- start -----------*/
    'supannMailPerso' => array (
      'label' => 'Personal e-mail address',
      'ldap_type' => 'ascii',
      'html_type' => 'mail',
      'multiple' => 1,
      'check_data' => array (
        'email' => array(
          'msg' => "Given email address is invalid.",
        ),
      ),
      'validation' => array (
        array (
          'filter' => '(|(mail=%{val})(supannAutreMail=%{val})(supannMailPerso=%{val}))',
          'result' => 0,
          'except_current_object' => true,
          'msg' => 'This e-mail address is already assigned.',
        ),
      ),
      'rights' => array(
        'self' => 'w',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'homePhone' => array (
      'label' => 'Personal home phone number',
      'ldap_type' => 'ascii',
      'html_type' => 'tel',
      'multiple' => 1,
      'rights' => array(
        'self' => 'w',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'homePostalAddress' => array (
      'label' => 'Personal postal address',
      'ldap_type' => 'postaladdress',
      'html_type' => 'textarea',
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'labeledURI' => array (
      'label' => "Personal web site URL",
      'help_info' => "Please enter a valid website URL.",
      'ldap_type' => 'ascii',
      'html_type' => 'url',
      'check_data' => array (
        'regex' => array(
          'params' => array(
            'regex' => '/^https?:\/\/.*/',
          ),
          'msg' => "Invalid URL.",
        ),
      ),
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
        'self' => 'w',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /***************************************************************************************************
     *                                   Private contact info attributes
     **************************************************************************************************/

     /* ----------- start -----------*/
     'supannMailPrive' => array (
      'label' => 'Private e-mail address',
      'ldap_type' => 'ascii',
      'html_type' => 'supannMailPrive',
      'multiple' => 1,
      'rights' => array(
        'self' => 'w',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannTelephonePrive' => array (
      'label' => 'Private phone numbers',
      'ldap_type' => 'ascii',
      'html_type' => 'supannTelephonePrive',
      'multiple' => 1,
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannAdressePostalePrivee' => array (
      'label' => 'Private postal address',
      'ldap_type' => 'ascii',
      'html_type' => 'supannAdressePostalePrivee',
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'multiple' => 1,
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /***************************************************************************************************
     *                                   Student attributes
     **************************************************************************************************/

    /* ----------- start -----------*/
    'supannCodeINE' => array (
      'label' => 'INE code',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'validation' => array (
        array (
          'filter' => '(supannEtuId=%{val})',
          'result' => 0,
          'except_current_object' => true,
          'msg' => 'This INE code is already assigned.',
        ),
      ),
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannEtuId' => array (
      'label' => 'Student identifier',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'validation' => array (
        array (
          'filter' => '(supannEtuId=%{val})',
          'result' => 0,
          'except_current_object' => true,
          'msg' => 'This identifier is already assigned.',
        ),
      ),
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannEtuInscription' => array (
      'label' => 'Administrative and educational registrations',
      'ldap_type' => 'ascii',
      'html_type' => 'supannEtuInscription',
      'multiple' => 1,
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
      'dependAttrs' => array(
        'supannEtuDiplome',
        'supannEtuTypeDiplome',
        'supannEtuRegimeInscription',
        'supannEtuSecteurDisciplinaire',
        'supannEtuAnneeInscription',
        'supannEtuCursusAnnee',
        'supannEtuElementPedagogique',
        'supannEtuEtape',
        'supannEtuDateFin',
      )
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannEtuDiplome' => array (
      'label' => 'Degrees',
      'help_info' => 'Labelled code (for instance: {SIZE}0833434)',
      'ldap_type' => 'ascii',
      'html_type' => 'supannEtuDiplome',
      'generate_function' => 'generate_supannEtuDiplome',
      'check_data' => array (
        'regex' => array(
          'msg' => "Invalid labelled code.",
          'params' => array(
            'regex' => '/^{[^}]+}.+$/',
          ),
        ),
      ),
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannEtuTypeDiplome' => array (
      'label' => 'Type or category of prepared degree',
      'help_info' => 'SISE labelled code',
      'ldap_type' => 'ascii',
      'html_type' => 'supannEtuTypeDiplome',
      'generate_function' => 'generate_supannEtuTypeDiplome',
      'check_data' => array (
        'regex' => array(
          'msg' => "Invalid labelled code.",
          'params' => array(
            'regex' => '/^{[^}]+}.+$/',
          ),
        ),
      ),
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannEtuRegimeInscription' => array (
      'label' => 'SISE education types',
      'help_info' => 'SISE labelled code',
      'ldap_type' => 'ascii',
      'html_type' => 'supannEtuRegimeInscription',
      'generate_function' => 'generate_supannEtuRegimeInscription',
      'check_data' => array (
        'regex' => array(
          'msg' => "Invalid labelled code.",
          'params' => array(
            'regex' => '/^{[^}]+}.+$/',
          ),
        ),
      ),
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannEtuSecteurDisciplinaire' => array (
      'label' => 'Disciplinary sector',
      'help_info' => 'SISE labelled code of the disciplinary sector of a degree or training.',
      'ldap_type' => 'ascii',
      'html_type' => 'supannEtuSecteurDisciplinaire',
      'generate_function' => 'generate_supannEtuSecteurDisciplinaire',
      'check_data' => array (
        'regex' => array(
          'msg' => "Invalid labelled code.",
          'params' => array(
            'regex' => '/^{[^}]+}.+$/',
          ),
        ),
      ),
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannEtuAnneeInscription' => array (
      'label' => 'Registrations years',
      'ldap_type' => 'numeric',
      'html_type' => 'text',
      'generate_function' => 'generate_supannEtuAnneeInscription',
      'check_data' => array (
        'integer' => array(
          'msg' => "Invalid year.",
        ),
      ),
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannEtuCursusAnnee' => array (
      'label' => 'Curriculum and year',
      'help_info' => "Format: “Xn” where X is one of values L, M, D, X and n is the current year in degree. If year isn't known, it could be omitted.",
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'generate_function' => 'generate_supannEtuCursusAnnee',
      'check_data' => array (
        'regex' => array(
          'msg' => "Invalid Xn code.",
          'params' => array(
            'regex' => '/^[LMDX][0-9]+$/',
          ),
        ),
      ),
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannEtuElementPedagogique' => array (
      'label' => 'Instruction elements',
      'ldap_type' => 'ascii',
      'html_type' => 'supannEtuElementPedagogique',
      'generate_function' => 'generate_supannEtuElementPedagogique',
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannEtuEtape' => array (
      'label' => 'Step',
      'ldap_type' => 'ascii',
      'html_type' => 'supannEtuEtape',
      'generate_function' => 'generate_supannEtuEtape',
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannEtuDateFin' => array (
      'label' => 'End validity date (as student)',
      'ldap_type' => 'date',
      'html_type' => 'date',
      'html_options' => array(
        'time' => false,
        'showNowButton' => False,
      ),
      'generate_function' => 'generate_supannEtuDateFin',
      'required' => 0,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
    ),
    /* ----------- end -----------*/

    /***************************************************************************************************
     *                                   Agents info attributes
     **************************************************************************************************/

     /* ----------- start -----------*/
     'supannEmpId' => array (
       'label' => 'Employee identifier',
       'ldap_type' => 'ascii',
       'html_type' => 'text',
       'validation' => array (
         array (
           'filter' => '(supannEmpId=%{val})',
           'result' => 0,
           'except_current_object' => true,
           'msg' => 'This identifier is already assigned.',
         ),
       ),
       'rights' => array(
         'self' => 'r',
         'admin' => 'w',
         'sysaccount' => 'r',
       ),
       'view' => 1,
       'form' => array (
         'modify' => 1,
         'create' => 1
       ),
     ),
     /* ----------- end -----------*/

     /* ----------- start -----------*/
     'supannEmpCorps' => array (
       'label' => "Body of membership",
       'ldap_type' => 'ascii',
       'html_type' => 'supannEmpCorps',
       'multiple' => 0,
       'rights' => array(
         'self' => 'r',
         'admin' => 'w',
         'sysaccount' => 'r',
       ),
       'view' => 1,
       'form' => array (
         'modify' => 1,
         'create' => 1
       ),
     ),
     /* ----------- end -----------*/

     /* ----------- start -----------*/
    'supannEmpDateFin' => array (
      'label' => 'End validity date (as agent)',
      'ldap_type' => 'date',
      'html_type' => 'date',
      'html_options' => array(
        'time' => false,
        'showNowButton' => False,
      ),
      'required' => 0,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array(
        'modify' => 1,
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannEmpProfil' => array (
      'label' => 'Profiles (as agent)',
      'ldap_type' => 'ascii',
      'html_type' => 'supannEmpProfil',
      'required' => 0,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array(
        'modify' => 1,
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannActivite' => array (
      'label' => 'Activities',
      'ldap_type' => 'ascii',
      'html_type' => 'supannActivite',
      'multiple' => 1,
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1,
        'create' => 1
      ),
    ),
    /* ----------- end -----------*/

    /***************************************************************************************************
     *                                   External person attributes
     **************************************************************************************************/

     /* ----------- start -----------*/
    'supannExtDateFin' => array (
      'label' => 'End validity date (as external)',
      'ldap_type' => 'date',
      'html_type' => 'date',
      'html_options' => array(
        'time' => false,
        'showNowButton' => False,
      ),
      'required' => 0,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array(
        'modify' => 1,
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannExtProfil' => array (
      'label' => 'Profiles (as external)',
      'ldap_type' => 'ascii',
      'html_type' => 'supannExtProfil',
      'required' => 0,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array(
        'modify' => 1,
      ),
    ),
    /* ----------- end -----------*/

    /***************************************************************************************************
     *                                   Technical Attributes
     **************************************************************************************************/

     /* ----------- start -----------*/
    'supannRefId' => array (
      'label' => 'Other identifiers',
      'help_info' => 'Identifiers of this LDAP object in other applications. These identifiers must be prefix with application name in uppercase and in brackets.',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'multiple' => 1,
      'check_data' => array (
        'regex' => array(
          'msg' => "Identifiers must only contain alphanumeric values, dots (.) and dashes (-) and be prefixed with application name in uppercase and in brackets.",
          'params' => array('regex' => '/^\{[A-Z0-9-_\.\:]+}[a-zA-Z0-9-_\.]*$/'),
        ),
      ),
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'create' => 1,
        'modify' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'userCertificate' => array (
      'label' => 'X.509 certificate',
      'ldap_type' => 'ascii',
      'html_type' => 'textarea',
      'rights' => array(
              'self' => 'w',
              'admin' => 'w',
      ),
      'view' => 1,
      'form' => array (
              'modify' => 1,
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannAliasLogin' => array (
      'label' => 'Identifier alias',
      'help_info' => "Identifier could only contain letters, digits, dots (.), dashes (-) and underscores (_).",
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'required' => 0,
      'check_data' => array (
        'regex' => array(
          'msg' => "Identifier could only contain letters, digits, dots (.), dashes (-) and underscores (_).",
          'params' => array('regex' => '/^[a-zA-Z0-9-_\.]*$/'),
        ),
      ),
      'validation' => array (
        array (
          'filter' => '(|(uid=%{val})(supannAliasLogin=%{val}))',
          'result' => 0,
          'msg' => 'This identifier is already used.',
          'except_current_object' => true,
        ),
      ),
      'rights' => array(
        'self' => 'w',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
      'form' => array (
        'modify' => 1
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'eduPersonUniqueId' => array (
      'label' => 'Globally unique & opaque identifier',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'generate_function' => 'generate_eduPersonUniqueId',
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'eduPersonPrincipalName' => array (
      'label' => 'Global identifier',
      'help_info' => "Identifier used in Identity federation context to globally identify a user. It has the same syntax as an e-mail address.",
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'required' => 1,
      'check_data' => array (
        'regex' => array(
          'params' => array(
            'regex' => '/^.*@.*$/',
          ),
        ),
      ),
      'generate_function' => 'generate_eduPersonPrincipalName',
      'validation' => array (
        array (
          'filter' => '(|(eduPersonPrincipalName=%{val})(eduPersonPrincipalNamePrior=%{val}))',
          'result' => 0,
          'except_current_object' => true,
          'msg' => 'This global identifier is already affected.',
        ),
      ),
      'view' => 1,
      'rights' => array(
        'self' => 'r',
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'form' => array (
        'modify' => 1,
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'eduPersonPrincipalNamePrior' => array (
      'label' => 'Old global identifiers',
      'help_info' => "Identifiers previously used in Identity federation context to globally identify a user.",
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'multiple' => 1,
      'check_data' => array (
        'regex' => array(
          'params' => array(
            'regex' => '/^.*@.*$/',
          ),
        ),
      ),
      'generate_function' => 'generate_eduPersonPrincipalNamePrior',
      'validation' => array (
        array (
          'filter' => '(|(eduPersonPrincipalName=%{val})(eduPersonPrincipalNamePrior=%{val}))',
          'result' => 0,
          'except_current_object' => true,
          'msg' => 'This global identifier is already affected.',
        ),
      ),
      'view' => 1,
      'rights' => array(
        'self' => 'r',
        'admin' => 'r',
        'sysaccount' => 'r',
      ),
    ),
    /* ----------- end -----------*/

    /* ----------- start -----------*/
    'supannConsentement' => array (
      'label' => 'User consents',
      'ldap_type' => 'ascii',
      'html_type' => 'text',
      'multiple' => 1,
      'rights' => array(
        'admin' => 'w',
        'sysaccount' => 'r',
      ),
      'view' => 1,
    ),
    /* ----------- end -----------*/

  ) // Fin args
);

@include('config.LSobjects.phpLdapAdmin.php');
if (defined('LS_SUPANN_ENABLE_PPOLICY') && constant('LS_SUPANN_ENABLE_PPOLICY')) {
  include('/usr/share/ldapsaisie/conf/LSobjects/config.LSobjects.common-pwdPolicyAccount.php');
  $GLOBALS['LSobjects']['supannPerson']['LSform']['layout']['pwdPolicy'] = $GLOBALS['pwdPolicyAccountAttrs_LSform_layout'];
  $GLOBALS['LSobjects']['supannPerson']['attrs'] = array_merge(
    $GLOBALS['LSobjects']['supannPerson']['attrs'],
    $GLOBALS['pwdPolicyAccountAttrs']
  );
}
